#!/bin/bash


function check_kubeasz() {
    # 检测 kubeasz 容器是否存在
    docker ps |grep kubeasz >/dev/null 2>&1
      if [ $? -eq 0 ]; then
        return 0
      else
        return 1
      fi
}



function allinone_add_node() {
    runtime=$(kubectl describe no "$(kubectl  get no | grep master | awk '{print $1}')" |grep  Runtime)
    if [[  $runtime =~ "containerd"  ]];then
        log_error "k8s runtime containerd 不支持自动添加node"
        exit 12
    fi
    nu=0
    for i in ${IP_LIST[@]};do
        let nu++
    done
    if [[ $nu != 1 ]];then
       log_error "单机安装只能填写一个IP地址，请查看 config/all.conf [NODE] 配置"
       exit 11
    fi
    if [ ! -d /etc/kubeasz/down ];then
       log_error "not found /etc/kubeasz 目录，脚本必须要在第一安装节点执行"
       exit 10
    fi
    # 检测 kubeasz 容器是否存在
    \cp -arf /etc/kubeasz/bin/containerd-bin/* /etc/kubeasz/bin/
    check_kubeasz
    if [ $? -eq 0 ];then
       log_info "开始添加节点操作"
       cp /etc/kubeasz/clusters/default/hosts /etc/kubeasz/clusters/default/hosts.$(date +%Y%H%M)
       sed -i "/"${IP_LIST[@]}"/d" /etc/kubeasz/clusters/default/hosts
       sed -i 's#CONTAINER_RUNTIME\=\"containerd\"#CONTAINER_RUNTIME\=\"docker\"#g' /etc/kubeasz/clusters/default/hosts
       sed -i  "/\[kube_node\]/a\\"${IP_LIST[@]}"" /etc/kubeasz/clusters/default/hosts
       docker exec kubeasz  bash -c "mkdir /usr/libexec/"
       docker exec kubeasz  bash -c "ln -s /usr/bin/python /usr/libexec/platform-python"
       docker exec kubeasz  bash -c "cd /etc/kubeasz/ &&  \
       ansible-playbook -i \"/etc/kubeasz/clusters/default/hosts\" \"/etc/kubeasz/playbooks/22.addnode.yml\" \
       -e \"NODE_TO_ADD=${IP_LIST[@]}\" -e \"@/etc/kubeasz/clusters/default/config.yml\""
       log_success "${IP_LIST[@]} 节点添加成功"
    else
       log_info "开始添加节点操作"
       log_info "启动 kubeasz 容器"
       /etc/kubeasz/ezdown -S
       cp /etc/kubeasz/clusters/default/hosts /etc/kubeasz/clusters/default/hosts.$(date +%Y%H%M)
       sed -i "/"${IP_LIST[@]}"/d" /etc/kubeasz/clusters/default/hosts
       sed -i 's#CONTAINER_RUNTIME\=\"containerd\"#CONTAINER_RUNTIME\=\"docker\"#g' /etc/kubeasz/clusters/default/hosts
       sed -i  "/\[kube_node\]/a\\"${IP_LIST[@]}"" /etc/kubeasz/clusters/default/hosts
       docker exec kubeasz  bash -c "mkdir /usr/libexec/"
       docker exec kubeasz  bash -c "ln -s /usr/bin/python /usr/libexec/platform-python"
       docker exec kubeasz  bash -c "cd /etc/kubeasz/ &&  \
       ansible-playbook -i \"/etc/kubeasz/clusters/default/hosts\" \"/etc/kubeasz/playbooks/22.addnode.yml\" \
       -e \"NODE_TO_ADD=${IP_LIST[@]}\" -e \"@/etc/kubeasz/clusters/default/config.yml\""
       log_success "${IP_LIST[@]} 节点添加成功"
    fi
}



function cluster_add_node() {
    if [ ! -f "${PACKAGE}" ];then
        log_error "未找到 "${PACKAGE}" 相关安装包，请先下载到 $SHELL_ROOTDIR \
         下载地址： "https://download.edoc2.com:5999/scripts/k8s/add_node/add_node_package.tar.gz"
        "
        exit 13
    fi
    harbor_check
    tar xf add_node_package.tar.gz
    for ip in ${IP_LIST[@]};do
        log_info "开始添加 $ip 节点"
        u=$(get_node_attribute NODE $ip user)
        hostname=$(get_node_attribute NODE $ip hostname)
        if ! grep "$ip" /etc/hosts >/dev/null;then
             echo "$ip $hostname" >> /etc/hosts
        fi
        copy_systemfile $u $ip
        remote_sehll $u $ip $hostname
        if [ -z ${SOURCE_DATE} ];then
            source=$(kubectl get no |awk 'NR==2{print $1}')
            source_date  $u $ip $source
        else 
            source_date  $u $ip $SOURCE_DATE
        fi
        start_service   $u $ip
    done
}




function add_node() {
    if [ "${TYPE}" = "cluster" ];then
       cluster_add_node
    else
       allinone_add_node
    fi
}

function node_delete() {
    if [ "${TYPE}" = "cluster" ];then
     for ip in ${IP_LIST[@]};do
          log_info "开始删除 $ip 节点"
          u=$(get_node_attribute NODE $ip user)
          hostname=$(get_node_attribute NODE $ip hostname)
          remove_cluster_all $u $ip $hostname
      done
    else
       allinone_add_node
    fi
    
}