#!/bin/bash

OUTPUT_TXT="/tmp/outpt.log"
INSTALL_LOG="/tmp/apm_node_install.log"


_color_red=$(TERM=xterm-256color tput setaf 1)
_color_green=$(TERM=xterm-256color tput setaf 2)
_color_normal=$(TREM=xterm-256color tput sgr0)
_color_blue=$(TERM=xterm-256color tput setaf 4)
_color_yellow=$(TERM=xterm-256color tput setaf 3)




function log_info() {
  local ts=$(date -Iseconds)
  # to log file
  echo -e "$ts [INFO] $@ " >> $INSTALL_LOG
  # to console (stderr)
  echo >&2  -e "$ts [INFO] $@"
  return 0
}

function log_error() {
  local ts=$(date -Iseconds)
  # to log file
  echo -e "$ts [ERROR] $@" >> $INSTALL_LOG
  # to console (stderr)
  echo >&2 -e "${_color_red} $ts [ERROR] $@${_color_normal}"
  return 0
}


function log_debug() {
  local ts=$(date -Iseconds)
  if [ $_DEBUG -eq 1 ];then
  # to log file
     echo -e "$ts [DEBUG] $@" >> $INSTALL_LOG
  # to console (stderr)
     echo >&2 -e "$ts [DEBUG] $@${_color_normal}"
  fi
  return 0
}

function log_success() {
  local ts=$(date -Iseconds)
  # to log file
  echo -e "$ts [SUCCESS] $@" >> $INSTALL_LOG
  # to console (stderr)
  echo -e "${_color_green} $ts [SUCCESS] $@${_color_normal}"
  return 0
}
